package com.hdp.pi.wechat.handler;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Node;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.hdp.customerservice.websocket.IMManager;
import com.hdp.pi.wechat.messages.AbstractMessage;

import java.util.Calendar;

/**
 * Created by Veal on 2015/5/11.
 */
@Component
public abstract class MessageHandler {

    /**
     *不同的消息对应的解析方法
     **/
    protected abstract AbstractMessage decode(String message) throws Exception;

    /**
     *处理通用信息 比如openid 日期
     **/
    public final void deCommonInfo(AbstractMessage entity,String message) throws Exception{
    	Document doc = DocumentHelper.parseText(message);
        Calendar calendar=Calendar.getInstance();
        calendar.setTimeInMillis(Long.parseLong(getXMLNodeText(doc,"/xml/CreateTime")));
        entity.openId=getXMLNodeText(doc,"/xml/FromUserName");
        entity.createTime=calendar.getTime();
    }
    
    public final String getXMLNodeText(Document doc,String path){
    	Node node = null;
    	try{
    		node=doc.getRootElement().selectSingleNode(path);
    	}catch(Exception e){
    		
    	}
    	return node!=null?node.getText():"";
    }
    /**
     *通用的消息处理
     * @throws Exception 
     **/
    public boolean onMessage(String msgType,Integer entCode,String appId,String message) throws Exception{
        if("".equals(message)){
            return false;
        }
        boolean result=Boolean.TRUE;//默认为处理成功
        AbstractMessage entity = decode(message);//特有字段需子类重写
        entity.msgType = msgType;//消息类型
        deCommonInfo(entity,message);//处理通用字段
        if(null != entity){
        	IMManager.pushMessage(entity);
        }
        return result;
    }
}
